type Cliente {
	id: ID
	nombre: String
	apellido: String
	empresa: String
	edad: Int
	tipo: TipoCliente
	emails: [Email]
	pedidos: [Pedido]
}

type Producto {
	id: ID
	nombre: String
	precio: Int
	stock: Int
}

type Pedido {
	id: ID
	pedido: [PedidoProducto]
	total: Int
	fecha: String
	cliente: String
	estado: EstadoPedido
}

input PedidoInput {
	id: ID
	pedido: [PedidoProductoInput]
	total: Int
	fecha: String
	cliente: String
	estado: EstadoPedido
}

input PedidoProductoInput {
	id: ID
	cantidad: Int
}

type PedidoProducto {
	id: ID
	cantidad: Int
}


type Email {
	email: String
}


input EmailInput {
	email: String!
}

""" Campo para los clientes nuevos """
input ClienteInput {
	id: ID
	nombre: String!
	apellido: String!
	empresa: String!
	emails: [EmailInput]
	edad: Int
	tipo: TipoCliente
	pedidos: [PedidoInput]
	String: String
	
}

input ProductoInput {
	id: ID
	nombre: String!
	precio: Int!
	stock: Int!
}

""" Asigna la categoria del cliente """
enum TipoCliente {
	BASICO
	PREMIUM
}

enum EstadoPedido {
	PENDIENTE
	COMPLETADO
	CANCELADO

}

type ClienteTotal {
	total : Float
	cliente: [Cliente]
}

type Query {
	getClientes(limit: Int , offset: Int ) : [Cliente]
	getCliente(id: ID!) : Cliente
	totalClientes : String
	getProductos(limit: Int , offset: Int, stock: Boolean ) : [Producto]
	getProducto(id: ID!) : Producto
	totalProductos : String
	obtenerPedido(clienteId: String!) : [Pedido]
	topClientes : [ClienteTotal]
}

""" Mutation para crear nuevos clientes """
type Mutation {
	#Nombre del resolver, input con datos y valor que retorna
	""" Te permite crear nuevos clientes """
	crearCliente(input: ClienteInput) : Cliente
	""" Te permite actualizar un cliente """
	actualizarCliente(input: ClienteInput) : Cliente
	""" Te permite eliminar un cliente """
	eliminarCliente(id: ID) : String
	""" Te permite crear nuevos productos """
	nuevoProducto(input: ProductoInput) : Producto
	actualizarProducto(input: ProductoInput) : Producto
	eliminarProducto(id: ID) : String
	nuevoPedido(input: PedidoInput) : Pedido
	actualizarEstado(input: PedidoInput) : String
	

}